changeset 4397:fb1fc6c9289e SDL-1.2

Reverted accidental commit.
author Ryan C. Gordon <icculus@icculus.org>
date Sun, 17 Jan 2010 05:19:32 +0000
parents f5d3f7fa071d
children fe15c4e8efe6
files build-scripts/fatbuild.sh
diffstat 1 files changed, 74 insertions(+), 131 deletions(-) [+]
line wrap: on
line diff
--- a/build-scripts/fatbuild.sh	Sun Jan 17 05:17:59 2010 +0000
+++ b/build-scripts/fatbuild.sh	Sun Jan 17 05:19:32 2010 +0000
@@ -5,98 +5,96 @@
 # Number of CPUs (for make -j)
 NCPU=`sysctl -n hw.ncpu`
 NJOB=$NCPU
+#NJOB=`expr $NCPU + 1`
 
 # Generic, cross-platform CFLAGS you always want go here.
 CFLAGS="-O3 -g -pipe"
 
-# PowerPC 32-bit configure flags (10.4 runtime compatibility)
-# We dynamically load X11, so using the system X11 headers is fine.
-CONFIG_PPC="--build=`uname -p`-apple-darwin --host=powerpc-apple-darwin \
+# Locate Xcode SDK path
+SDK_PATH=/Developer/SDKs
+if [ ! -d $SDK_PATH ]; then
+    echo "Couldn't find SDK path"
+    exit 1
+fi
+
+# See if we can use 10.2 or 10.3 runtime compatibility
+if [ -d "$SDK_PATH/MacOSX10.2.8.sdk" ]; then
+    # PowerPC configure flags (10.2 runtime compatibility)
+    # We dynamically load X11, so using the system X11 headers is fine.
+    CONFIG_PPC="--build=`uname -p`-apple-darwin --host=powerpc-apple-darwin \
 --x-includes=/usr/X11R6/include --x-libraries=/usr/X11R6/lib"
 
-# PowerPC 32-bit compiler flags
-CC_PPC="gcc-4.0 -arch ppc"
-CXX_PPC="g++-4.0 -arch ppc"
-CFLAGS_PPC="-mmacosx-version-min=10.4"
-CPPFLAGS_PPC="-DMAC_OS_X_VERSION_MIN_REQUIRED=1040 \
+    # PowerPC compiler flags
+    CC_PPC="gcc-3.3 -arch ppc"
+    CXX_PPC="g++-3.3 -arch ppc"
+    CFLAGS_PPC=""
+    CPPFLAGS_PPC="-DMAC_OS_X_VERSION_MIN_REQUIRED=1020 \
 -nostdinc \
--F/Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks \
--I/Developer/SDKs/MacOSX10.4u.sdk/usr/lib/gcc/powerpc-apple-darwin10/4.0.1/include \
--isystem /Developer/SDKs/MacOSX10.4u.sdk/usr/include"
+-F$SDK_PATH/MacOSX10.2.8.sdk/System/Library/Frameworks \
+-I$SDK_PATH/MacOSX10.2.8.sdk/usr/include/gcc/darwin/3.3 \
+-isystem $SDK_PATH/MacOSX10.2.8.sdk/usr/include"
 
-# PowerPC 32-bit linker flags
-LFLAGS_PPC="-arch ppc -mmacosx-version-min=10.4 \
--F/Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks \
--L/Developer/SDKs/MacOSX10.4u.sdk/usr/lib/gcc/powerpc-apple-darwin10/4.0.1 \
--Wl,-syslibroot,/Developer/SDKs/MacOSX10.4u.sdk"
+    # PowerPC linker flags 
+    LFLAGS_PPC="-Wl,-headerpad_max_install_names -arch ppc \
+-L$SDK_PATH/MacOSX10.2.8.sdk/usr/lib/gcc/darwin/3.3 \
+-F$SDK_PATH/MacOSX10.2.8.sdk/System/Library/Frameworks \
+-Wl,-syslibroot,$SDK_PATH/MacOSX10.2.8.sdk"
 
-# PowerPC 64-bit configure flags (10.5 runtime compatibility)
-# We dynamically load X11, so using the system X11 headers is fine.
-CONFIG_PPC64="--build=`uname -p`-apple-darwin --host=powerpc-apple-darwin \
+else # 10.2 or 10.3 SDK
+
+    # PowerPC configure flags (10.3 runtime compatibility)
+    # We dynamically load X11, so using the system X11 headers is fine.
+    CONFIG_PPC="--build=`uname -p`-apple-darwin --host=powerpc-apple-darwin \
 --x-includes=/usr/X11R6/include --x-libraries=/usr/X11R6/lib"
 
-# PowerPC 64-bit compiler flags
-CC_PPC64="gcc-4.0 -arch ppc64"
-CXX_PPC64="g++-4.0 -arch ppc64"
-CFLAGS_PPC64="-mmacosx-version-min=10.5"
-CPPFLAGS_PPC64="-DMAC_OS_X_VERSION_MIN_REQUIRED=1050 \
+    # PowerPC compiler flags
+    CC_PPC="gcc-4.0 -arch ppc"
+    CXX_PPC="g++-4.0 -arch ppc"
+    CFLAGS_PPC=""
+    CPPFLAGS_PPC="-DMAC_OS_X_VERSION_MIN_REQUIRED=1030 \
 -nostdinc \
--F/Developer/SDKs/MacOSX10.5.sdk/System/Library/Frameworks \
--I/Developer/SDKs/MacOSX10.5.sdk/usr/lib/gcc/powerpc-apple-darwin10/4.0.1/include \
--isystem /Developer/SDKs/MacOSX10.5.sdk/usr/include"
+-F$SDK_PATH/MacOSX10.3.9.sdk/System/Library/Frameworks \
+-I$SDK_PATH/MacOSX10.3.9.sdk/usr/lib/gcc/powerpc-apple-darwin9/4.0.1/include \
+-isystem $SDK_PATH/MacOSX10.3.9.sdk/usr/include"
 
-# PowerPC 64-bit linker flags
-LFLAGS_PPC64="-arch ppc64 -mmacosx-version-min=10.5 \
--F/Developer/SDKs/MacOSX10.5.sdk/System/Library/Frameworks \
--L/Developer/SDKs/MacOSX10.5.sdk/usr/lib/gcc/powerpc-apple-darwin10/4.0.1/ppc64 \
--Wl,-syslibroot,/Developer/SDKs/MacOSX10.5.sdk"
+    # PowerPC linker flags
+    LFLAGS_PPC="-Wl,-headerpad_max_install_names -arch ppc -mmacosx-version-min=10.3 \
+-L$SDK_PATH/MacOSX10.3.9.sdk/usr/lib/gcc/powerpc-apple-darwin9/4.0.1 \
+-F$SDK_PATH/MacOSX10.3.9.sdk/System/Library/Frameworks \
+-Wl,-syslibroot,$SDK_PATH/MacOSX10.3.9.sdk"
 
-# Intel 32-bit configure flags (10.4 runtime compatibility)
+fi # 10.2 or 10.3 SDK
+
+# Intel configure flags (10.4 runtime compatibility)
 # We dynamically load X11, so using the system X11 headers is fine.
 CONFIG_X86="--build=`uname -p`-apple-darwin --host=i386-apple-darwin \
 --x-includes=/usr/X11R6/include --x-libraries=/usr/X11R6/lib"
 
-# Intel 32-bit configure flags (10.4 runtime compatibility)
-# We dynamically load X11, so using the system X11 headers is fine.
-CONFIG_X86="--build=`uname -p`-apple-darwin --host=i386-apple-darwin \
---x-includes=/usr/X11R6/include --x-libraries=/usr/X11R6/lib"
+# They changed this to "darwin10" in Xcode 3.2 (Snow Leopard).
+GCCUSRPATH="$SDK_PATH/MacOSX10.4u.sdk/usr/lib/gcc/i686-apple-darwin9/4.0.1"
+if [ ! -d "$GCCUSRPATH" ]; then
+    GCCUSRPATH="$SDK_PATH/MacOSX10.4u.sdk/usr/lib/gcc/i686-apple-darwin10/4.0.1"
+fi
 
-# Intel 32-bit compiler flags
+if [ ! -d "$GCCUSRPATH" ]; then
+    echo "Couldn't find any GCC usr path"
+    exit 1
+fi
+
+# Intel compiler flags
 CC_X86="gcc-4.0 -arch i386"
 CXX_X86="g++-4.0 -arch i386"
 CFLAGS_X86="-mmacosx-version-min=10.4"
 CPPFLAGS_X86="-DMAC_OS_X_VERSION_MIN_REQUIRED=1040 \
 -nostdinc \
--F/Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks \
--I/Developer/SDKs/MacOSX10.4u.sdk/usr/lib/gcc/i686-apple-darwin10/4.0.1/include \
--isystem /Developer/SDKs/MacOSX10.4u.sdk/usr/include"
-
-# Intel 32-bit linker flags
-LFLAGS_X86="-arch i386 -mmacosx-version-min=10.4 \
--F/Developer/SDKs/MacOSX10.4u.sdk/System/Library/Frameworks \
--L/Developer/SDKs/MacOSX10.4u.sdk/usr/lib/gcc/i686-apple-darwin10/4.0.1 \
--Wl,-syslibroot,/Developer/SDKs/MacOSX10.4u.sdk"
-
-# Intel 64-bit configure flags (10.5 runtime compatibility)
-# We dynamically load X11, so using the system X11 headers is fine.
-CONFIG_X64="--build=`uname -p`-apple-darwin --host=i386-apple-darwin \
---x-includes=/usr/X11R6/include --x-libraries=/usr/X11R6/lib"
+-F$SDK_PATH/MacOSX10.4u.sdk/System/Library/Frameworks \
+-I$GCCUSRPATH/include \
+-isystem $SDK_PATH/MacOSX10.4u.sdk/usr/include"
 
-# Intel 64-bit compiler flags
-CC_X64="gcc-4.0 -arch x86_64"
-CXX_X64="g++-4.0 -arch x86_64"
-CFLAGS_X64="-mmacosx-version-min=10.5"
-CPPFLAGS_X64="-DMAC_OS_X_VERSION_MIN_REQUIRED=1050 \
--nostdinc \
--F/Developer/SDKs/MacOSX10.5.sdk/System/Library/Frameworks \
--I/Developer/SDKs/MacOSX10.5.sdk/usr/lib/gcc/i686-apple-darwin10/4.0.1/include \
--isystem /Developer/SDKs/MacOSX10.5.sdk/usr/include"
-
-# Intel 64-bit linker flags
-LFLAGS_X64="-arch x86_64 -mmacosx-version-min=10.5 \
--F/Developer/SDKs/MacOSX10.5.sdk/System/Library/Frameworks \
--L/Developer/SDKs/MacOSX10.5.sdk/usr/lib/gcc/i686-apple-darwin10/4.0.1/x86_64 \
--Wl,-syslibroot,/Developer/SDKs/MacOSX10.5.sdk"
+# Intel linker flags
+LFLAGS_X86="-Wl,-headerpad_max_install_names -arch i386 -mmacosx-version-min=10.4 \
+-L$GCCUSRPATH \
+-Wl,-syslibroot,$SDK_PATH/MacOSX10.4u.sdk"
 
 #
 # Find the configure script
@@ -108,8 +106,8 @@
 #
 # Figure out which phase to build:
 # all,
-# configure, configure-ppc, configure-ppc64, configure-x86, configure-x64
-# make, make-ppc, make-ppc64, make-x86, make-x64, merge
+# configure, configure-ppc, configure-x86,
+# make, make-ppc, make-x86, merge
 # install
 # clean
 if test x"$1" = x; then
@@ -120,52 +118,32 @@
 case $phase in
     all)
         configure_ppc="yes"
-        #configure_ppc64="yes"
         configure_x86="yes"
-        configure_x64="yes"
         make_ppc="yes"
-        #make_ppc64="yes"
         make_x86="yes"
-        make_x64="yes"
         merge="yes"
         ;;
     configure)
         configure_ppc="yes"
-        configure_ppc64="yes"
         configure_x86="yes"
-        configure_x64="yes"
         ;;
     configure-ppc)
         configure_ppc="yes"
         ;;
-    configure-ppc64)
-        configure_ppc64="yes"
-        ;;
     configure-x86)
         configure_x86="yes"
         ;;
-    configure-x64)
-        configure_x64="yes"
-        ;;
     make)
         make_ppc="yes"
-        make_ppc64="yes"
         make_x86="yes"
-        make_x64="yes"
         merge="yes"
         ;;
     make-ppc)
         make_ppc="yes"
         ;;
-    make-ppc64)
-        make_ppc64="yes"
-        ;;
     make-x86)
         make_x86="yes"
         ;;
-    make-x64)
-        make_x64="yes"
-        ;;
     merge)
         merge="yes"
         ;;
@@ -193,24 +171,16 @@
         ;;
     clean)
         clean_ppc="yes"
-        clean_ppc64="yes"
         clean_x86="yes"
-        clean_x64="yes"
         ;;
     clean-ppc)
         clean_ppc="yes"
         ;;
-    clean-ppc64)
-        clean_ppc64="yes"
-        ;;
     clean-x86)
         clean_x86="yes"
         ;;
-    clean-x64)
-        clean_x64="yes"
-        ;;
     *)
-        echo "Usage: $0 [all|configure[-ppc|-ppc64|-x86|-x64]|make[-ppc|-ppc64|-x86|-x64]|merge|install|clean[-ppc|-ppc64|-x86|-x64]]"
+        echo "Usage: $0 [all|configure[-ppc|-x86]|make[-ppc|-x86]|merge|install|clean]"
         exit 1
         ;;
 esac
@@ -218,15 +188,9 @@
     powerpc)
         native_path=ppc
         ;;
-    powerpc64)
-        native_path=ppc64
-        ;;
     *86)
         native_path=x86
         ;;
-    x86_64)
-        native_path=x64
-        ;;
     *)
         echo "Couldn't figure out native architecture path"
         exit 1
@@ -236,7 +200,7 @@
 #
 # Create the build directories
 #
-for dir in build build/ppc build/ppc64 build/x86 build/x64; do
+for dir in build build/ppc build/x86; do
     if test -d $dir; then
         :
     else
@@ -245,7 +209,7 @@
 done
 
 #
-# Build the PowerPC 32-bit binary
+# Build the PowerPC binary
 #
 if test x$configure_ppc = xyes; then
     (cd build/ppc && \
@@ -256,18 +220,7 @@
 fi
 
 #
-# Build the PowerPC 64-bit binary
-#
-if test x$configure_ppc64 = xyes; then
-    (cd build/ppc64 && \
-     sh ../../configure $CONFIG_PPC64 CC="$CC_PPC64" CXX="$CXX_PPC64" CFLAGS="$CFLAGS $CFLAGS_PPC64" CPPFLAGS="$CPPFLAGS_PPC64" LDFLAGS="$LFLAGS_PPC64") || exit 2
-fi
-if test x$make_ppc64 = xyes; then
-    (cd build/ppc64 && ls include && make -j$NJOB) || exit 3
-fi
-
-#
-# Build the Intel 32-bit binary
+# Build the Intel binary
 #
 if test x$configure_x86 = xyes; then
     (cd build/x86 && \
@@ -278,25 +231,15 @@
 fi
 
 #
-# Build the Intel 32-bit binary
-#
-if test x$configure_x64 = xyes; then
-    (cd build/x64 && \
-     sh ../../configure $CONFIG_X64 CC="$CC_X64" CXX="$CXX_X64" CFLAGS="$CFLAGS $CFLAGS_X64" CPPFLAGS="$CPPFLAGS_X64" LDFLAGS="$LFLAGS_X64") || exit 2
-fi
-if test x$make_x64 = xyes; then
-    (cd build/x64 && make -j$NJOB) || exit 3
-fi
-
-#
 # Combine into fat binary
 #
 if test x$merge = xyes; then
     output=.libs
     sh $auxdir/mkinstalldirs build/$output
     cd build
-    target=`find . -mindepth 4 -maxdepth 4 -type f -name '*.dylib' | head -1 | sed 's|.*/||'`
-    (lipo -create -o $output/$target `find . -mindepth 4 -maxdepth 4 -type f -name "*.dylib"` &&
+    target=`find . -mindepth 3 -type f -name '*.dylib' | head -1 | sed 's|.*/||'`
+    (lipo -create -o $output/$target `find . -mindepth 3 -type f -name "*.dylib"` &&
+     ln -sf $target $output/libSDL-1.2.0.dylib &&
      ln -sf $target $output/libSDL.dylib &&
      lipo -create -o $output/libSDL.a */build/.libs/libSDL.a &&
      cp $native_path/build/.libs/libSDL.la $output &&